!To run older older Setups like BoTpl9.1 that only spot 9.1 or prior this sets up a fake 9.0
!I think 9.1 is still active for some so I chose 9.0
!Project requires ABC Defines 

  PROGRAM
VersionNo       STRING('9.0')                   !FYI see Clarion9 below in C:\Users\Public\Documents\SoftVelocity\Clarion9
RootPath        STRING('C:\Clarion9_Fake')      !Written to Registry HKLM SOFTWARE\...\Uninstall InstallLocation                  
RegKeyInstaller STRING('{{905A4CB0-90B8-11E2-3D6C-299385554AE1}')   !9.0     
UninstallPath   STRING('SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall') !+ \{hhhhhh-...       
InstallLocation STRING('InstallLocation')
PublicClarion   STRING('SoftVelocity\Clarion9\Accessory')          !In C:\Users\Public\Documents\
!UninstallPath   STRING('SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall')        

!    10:02:09.1874616 AM	BoTpl44SU.exe	26264	RegQueryValue	
!    HKLM\SOFTWARE\WOW6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{5FBB5960-7EDC-11E3-3D6C-05B078044AE1}\InstallLocation	
!    SUCCESS	Type: REG_SZ, Length: 26, Data: D:\Clarion91

!RegKey_8_0  STRING('{{19336650-F595-11DF-72AE-06609D572CD6}')  !These are all EE, should not matter
!RegKey_9_0  STRING('{{905A4CB0-90B8-11E2-3D6C-299385554AE1}') 
!RegKey_9_1   STRING('{{5FBB5960-7EDC-11E3-3D6C-05B078044AE1}') 
!RegKey_10_0 STRING('{{9B04EBD0-8ACA-11E4-4823-04D0CF9C0029}') 
!RegKey_11_0 STRING('{{40387FE0-70B9-11E8-41BB-330DD2345AF1}')   !Also 11.1 

MsgCaption  STRING('Fake Clarion 9 Setup')   
  
  INCLUDE('CSIDL.EQU'),ONCE           !BO wants to write to C:\Users\Public\Documents\SoftVelocity\Clarion9\Accessory\Comsoft7\BoTpl 4.4\BCLabels
  INCLUDE('CSIDLFolder.inc'),ONCE 
FolderCls           CSIDLFolder
PublicDocsFolder    PSTRING(256)  
  MAP
FakeClarion PROCEDURE() 
MakeDir     PROCEDURE(STRING BaseDir,STRING SubDir)
    MODULE('Win32')
CreateDirectoryA   PROCEDURE( *CSTRING lpPathName, LONG lpSecurityAttributes=0),BOOL,PROC,RAW,PASCAL,DLL(1)
GetLastError       PROCEDURE(),LONG,PASCAL,DLL(1) 
    END
  END
  CODE
    FakeClarion()

FakeClarion PROCEDURE()

TestGetReg  STRING(400) 
    CODE
    !I have 9.1 installed so this tests GETREG works 
    !Message('GETREG 9.1 (HKLM, '& UninstallPath &'\'& RegKey_9_1 &' , InstallLocation) ||' & | 
    !        GETREG(REG_LOCAL_MACHINE,UninstallPath &'\'& RegKey_9_1,InstallLocation) ,'GETREG Test 9.1') 

!    DELETEREG(REG_LOCAL_MACHINE,UninstallPath &'\'& RegKeyInstaller,InstallLocation)  !Delete Key to allow retest
    TestGetReg = GETREG(REG_LOCAL_MACHINE,UninstallPath &'\'& RegKeyInstaller,InstallLocation) 
    IF TestGetReg THEN TestGetReg='||**** InstallLocation EXISTS in Reg = "' & CLIP(TestGetReg) & '" ****'.
    
    CASE MESSAGE('This will setup a fake Clarion install for Setup Builder '&|
         'to find.'&|
        '||   Version: <9>'&VersionNo&|
         '|   Root Path: <9>'&RootPath&|
         '|   Reg Key: <9>'&RegKeyInstaller&' '&|   
         '|   Reg Path: <9>'&UninstallPath&' '&|   
         '|   Reg Name: <9>'&InstallLocation&' '&|   
         CLIP(TestGetReg) & |
         '||This will make the folders and registry keys.'&|
         '|You must have "Run as Admin" to write to HKLM.', |
         'Fake Clarion Setup', ICON:Question, |
          'Setup Fake|Cancel', 2)
    OF 1  ! Name: Setup Fake
    OF 2 ; RETURN  ! Name: Cancel  (Default)
    END !CASE    
    
    MakeDir(RootPath,'')
    IF ~EXISTS(RootPath) THEN 
        Message('Failed to MakeRootDir ' & RootPath,MsgCaption)
        RETURN 
    END 

    !-----------------------
    !BoTPL writes to C:\Users\Public\Documents\SoftVelocity\Clarion9\Accessory\Comsoft7\BoTpl 4.4\BCLabels
    PublicDocsFolder = CLIP(FolderCls.ISystemFolder.GetDir(SV:CSIDL_COMMON_DOCUMENTS)) 
        !  Message('PublicDocsFolder=' & PublicDocsFolder,MsgCaption )
    IF ~PublicDocsFolder THEN 
        Message('Odd SV:CSIDL_COMMON_DOCUMENTS not found',MsgCaption) 
    ELSIF ~EXISTS(PublicDocsFolder &'\'& PublicClarion)  !C:\Users\Public\Documents\SoftVelocity\Clarion9\Accessory
        RUN('Explorer.exe /e,"' & PublicDocsFolder &'"')  

        CASE MESSAGE('Explorer is opened to: '&PublicDocsFolder&|
             '||In Public Documents YOU must make the below sub folders that some '&|
             'installs update:'&|
             '||Under: ' &  PublicDocsFolder &|
             '|Make:  ' &  PublicClarion &|
             '|', MsgCaption, ICON:Asterisk,'I Made Dirs|Cancel|Ignore',,MSGMODE:CANCOPY) 
        OF 1  ! Name: I Made Dirs
              IF ~EXISTS(PublicDocsFolder &'\'& PublicClarion) THEN STOP('Folder does not exist ' & PublicDocsFolder &'\'& PublicClarion).
        OF 2 ; RETURN  ! Name: Cancel  (Default)
        END !CASE
     END     
    !-----------------------
    
    IF PUTREG(REG_LOCAL_MACHINE,UninstallPath &'\'& RegKeyInstaller,'InstallLocation', RootPath, REG_SZ )
       Message('PUTREG failed error ' & Error() &  |
                '||'& UninstallPath &'|'& RegKeyInstaller &'  ' & InstallLocation & '|'& RootPath,MsgCaption)
       RETURN                 
    END 

    TestGetReg = GETREG(REG_LOCAL_MACHINE,UninstallPath &'\'& RegKeyInstaller ,InstallLocation) 
    IF ~TestGetReg THEN TestGetReg='GETREG Error ' & ERROR().
    IF TestGetReg <> RootPath THEN
       Message('PUTREG ' & InstallLocation & ' appears to have Failed||Wrote: ' & RootPath &'|ReRead: '& TestGetReg ,MsgCaption) 
    END 
    
    MakeDir(RootPath,'Bin')                     !Setup a few assume Install will do the rest 
    MakeDir(RootPath,'Accessory')               !BO worked find with just BIN setup
    MakeDir(RootPath,'Accessory\libsrc')       
    MakeDir(RootPath,'Accessory\libsrc\win')       
    MakeDir(RootPath,'Accessory\template')       
    MakeDir(RootPath,'Accessory\template\win')       
    
    Message(VersionNo & ' all setup in ' & RootPath, MsgCaption) 
    RETURN 
    
!------------------------------------------------------    
MakeDir PROCEDURE(STRING BaseDir,STRING SubDir)
cDir    CSTRING(256),AUTO
LastErr LONG,AUTO
    CODE
    cDir=CLIP(BaseDir) & CHOOSE(~SubDir,'','\'& CLIP(SubDir))
    IF ~CreateDirectoryA(cDir) THEN
        LastErr=GetLastError() 
        IF LastErr <> 183 THEN      !ERROR_ALREADY_EXISTS    EQUATE(183)
           Message('CreateDirectoryA error ' & LastErr &'|making ' & cDir,MsgCaption)  
        END  
    END 
    RETURN 